## You give it a mbox-format collection of emails, and it will try to
## apply them to the kernel using "applypatch"
##
-## applymbox [ -c .dotest/msg-number ] [ -q ] mail_archive [Signoff_file]"
+## applymbox [ -k ] [ -q ] (-c .dotest/msg-number | mail_archive) [Signoff_file]"
##
## The patch application may fail in the middle. In which case:
## (1) look at .dotest/patch and fix it up to apply
## use a Signoff_file, because applypatch wants to append the sign-off
## message to msg-clean every time it is run.
-query_apply= continue= resume=t
+. git-sh-setup-script || die "Not a git archive"
+
+keep_subject= query_apply= continue= resume=t
while case "$#" in 0) break ;; esac
do
case "$1" in
+ -k) keep_subject=-k ;;
-q) query_apply=t ;;
-c) continue="$2"; resume=f; shift ;;
-*) usage ;;
'')
rm -rf .dotest
mkdir .dotest
- mailsplit "$1" .dotest || exit 1
+ git-mailsplit "$1" .dotest || exit 1
+ shift
esac
+files=$(git-diff-cache --cached --name-only HEAD) || exit
+if [ "$files" ]; then
+ echo "Dirty index: cannot apply patches (dirty: $files)" >&2
+ exit 1
+fi
+
case "$query_apply" in
t) touch .dotest/.query_apply
esac
+case "$keep_subject" in
+-k) : >.dotest/.keep_subject
+esac
-for i in .dotest/0*
+signoff="$1"
+set x .dotest/0*
+shift
+while case "$#" in 0) break;; esac
do
- case "$resume,$continue" in
- f,$i) resume=t;;
- f,*) continue;;
- *)
- mailinfo .dotest/msg .dotest/patch <$i >.dotest/info || exit 1
- git-stripspace < .dotest/msg > .dotest/msg-clean
- ;;
- esac
- applypatch .dotest/msg-clean .dotest/patch .dotest/info "$2"
- ret=$?
- if [ $ret -ne 0 ]; then
+ i="$1"
+ case "$resume,$continue" in
+ f,$i) resume=t;;
+ f,*) continue;;
+ *)
+ git-mailinfo $keep_subject \
+ .dotest/msg .dotest/patch <$i >.dotest/info || exit 1
+ git-stripspace < .dotest/msg > .dotest/msg-clean
+ ;;
+ esac
+ while :; # for fixing up and retry
+ do
+ git-applypatch .dotest/msg-clean .dotest/patch .dotest/info "$signoff"
+ case "$?" in
+ 0 | 2 )
# 2 is a special exit code from applypatch to indicate that
# the patch wasn't applied, but continue anyway
- [ $ret -ne 2 ] && exit $ret
- fi
+ ;;
+ *)
+ ret=$?
+ if test -f .dotest/.query_apply
+ then
+ echo >&2 "* Patch failed."
+ echo >&2 "* You could fix it up in your editor and"
+ echo >&2 " retry. If you want to do so, say yes here"
+ echo >&2 " AFTER fixing .dotest/patch up."
+ echo >&2 -n "Retry [y/N]? "
+ read yesno
+ case "$yesno" in
+ [Yy]*)
+ continue ;;
+ esac
+ fi
+ exit $ret
+ esac
+ break
+ done
+ shift
done
# return to pristine
rm -fr .dotest